/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 28 "gram.y"


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#include <pthread.h>
#include <netinet/in.h>
#include <net/if.h>
#include <string.h>
#include <stdarg.h>
#include <netinet/ip6mh.h>
#include "mipv6.h"
#include "ha.h"
#include "mn.h"
#include "conf.h"
#include "policy.h"
#include "xfrm.h"
#include "prefix.h"
#include "util.h"
#include "ipsec.h"
#include "rtnl.h"

struct net_iface ni = {
	.mip6_if_entity = MIP6_ENTITY_NO,
	.mn_if_preference = POL_MN_IF_DEF_PREFERENCE,
	.is_tunnel = 0,
};
	
struct home_addr_info hai = {
	.ro_policies = LIST_HEAD_INIT(hai.ro_policies),
	.mob_net_prefixes = LIST_HEAD_INIT(hai.mob_net_prefixes)
};

LIST_HEAD(prefixes);

int mv_prefixes(struct list_head *list)
{
	struct list_head *l, *n;
	int res = 0;
	list_for_each_safe(l, n, &prefixes) {
		list_del(l);
		list_add_tail(l, list);
		res++;
	}
	return res;
}

struct policy_bind_acl_entry *bae = NULL;

struct ipsec_policy_set {
	struct in6_addr ha;
	struct list_head hoa_list;
};

struct ipsec_policy_set ipsec_ps = {
	.hoa_list = LIST_HEAD_INIT(ipsec_ps.hoa_list)
};

extern int lineno;
extern char *yytext;
extern char *incl_file; /* If not NULL, name of included file being parsed.
			 * If NULL, we are in main configuration file */

static void yyerror(char *s) {
	fprintf(stderr, "Error in configuration file %s ",
		incl_file ? incl_file : conf.config_file);
	fprintf(stderr, "at line %d: %s at '%s'\n", lineno, s, yytext);
}

static void uerror(const char *fmt, ...) {
	char s[1024];
	va_list args;

	fprintf(stderr, "Error in configuration file %s ",
		incl_file ? incl_file : conf.config_file);
	va_start(args, fmt);
	vsprintf(s, fmt, args);
	fprintf(stderr, "at line %d: %s\n", lineno, s);
	va_end(args);
}


#line 155 "gram.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_GRAM_H_INCLUDED
# define YY_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    QSTRING = 258,                 /* QSTRING  */
    ADDR = 259,                    /* ADDR  */
    BOOL = 260,                    /* BOOL  */
    NUMBER = 261,                  /* NUMBER  */
    DECIMAL = 262,                 /* DECIMAL  */
    NUMPAIR = 263,                 /* NUMPAIR  */
    MIP6ENTITY = 264,              /* MIP6ENTITY  */
    DEBUGLEVEL = 265,              /* DEBUGLEVEL  */
    DEBUGLOGFILE = 266,            /* DEBUGLOGFILE  */
    DOROUTEOPTIMIZATIONCN = 267,   /* DOROUTEOPTIMIZATIONCN  */
    DOROUTEOPTIMIZATIONMN = 268,   /* DOROUTEOPTIMIZATIONMN  */
    HOMEADDRESS = 269,             /* HOMEADDRESS  */
    HOMEAGENTADDRESS = 270,        /* HOMEAGENTADDRESS  */
    INITIALBINDACKTIMEOUTFIRSTREG = 271, /* INITIALBINDACKTIMEOUTFIRSTREG  */
    INITIALBINDACKTIMEOUTREREG = 272, /* INITIALBINDACKTIMEOUTREREG  */
    LINKNAME = 273,                /* LINKNAME  */
    HAMAXBINDINGLIFE = 274,        /* HAMAXBINDINGLIFE  */
    MNMAXHABINDINGLIFE = 275,      /* MNMAXHABINDINGLIFE  */
    MNMAXCNBINDINGLIFE = 276,      /* MNMAXCNBINDINGLIFE  */
    MAXMOBPFXADVINTERVAL = 277,    /* MAXMOBPFXADVINTERVAL  */
    MINMOBPFXADVINTERVAL = 278,    /* MINMOBPFXADVINTERVAL  */
    MNHOMELINK = 279,              /* MNHOMELINK  */
    HAHOMELINK = 280,              /* HAHOMELINK  */
    NONVOLATILEBINDINGCACHE = 281, /* NONVOLATILEBINDINGCACHE  */
    SENDMOBPFXSOLS = 282,          /* SENDMOBPFXSOLS  */
    SENDUNSOLMOBPFXADVS = 283,     /* SENDUNSOLMOBPFXADVS  */
    SENDMOBPFXADVS = 284,          /* SENDMOBPFXADVS  */
    IPSECPOLICYSET = 285,          /* IPSECPOLICYSET  */
    IPSECPOLICY = 286,             /* IPSECPOLICY  */
    IPSECTYPE = 287,               /* IPSECTYPE  */
    USEALTCOA = 288,               /* USEALTCOA  */
    USEESP = 289,                  /* USEESP  */
    USEAH = 290,                   /* USEAH  */
    USEIPCOMP = 291,               /* USEIPCOMP  */
    BLOCK = 292,                   /* BLOCK  */
    USEMNHAIPSEC = 293,            /* USEMNHAIPSEC  */
    KEYMNGMOBCAPABILITY = 294,     /* KEYMNGMOBCAPABILITY  */
    HOMEREGBINDING = 295,          /* HOMEREGBINDING  */
    MH = 296,                      /* MH  */
    MOBPFXDISC = 297,              /* MOBPFXDISC  */
    TUNNELHOMETESTING = 298,       /* TUNNELHOMETESTING  */
    TUNNELMH = 299,                /* TUNNELMH  */
    TUNNELPAYLOAD = 300,           /* TUNNELPAYLOAD  */
    USEMOVEMENTMODULE = 301,       /* USEMOVEMENTMODULE  */
    USEPOLICYMODULE = 302,         /* USEPOLICYMODULE  */
    MIP6CN = 303,                  /* MIP6CN  */
    MIP6MN = 304,                  /* MIP6MN  */
    MIP6HA = 305,                  /* MIP6HA  */
    INTERNAL = 306,                /* INTERNAL  */
    MNROPOLICY = 307,              /* MNROPOLICY  */
    ICMP = 308,                    /* ICMP  */
    ANY = 309,                     /* ANY  */
    DOROUTEOPT = 310,              /* DOROUTEOPT  */
    DEFAULTBINDINGACLPOLICY = 311, /* DEFAULTBINDINGACLPOLICY  */
    BINDINGACLPOLICY = 312,        /* BINDINGACLPOLICY  */
    MNADDRESS = 313,               /* MNADDRESS  */
    USECNBUACK = 314,              /* USECNBUACK  */
    INTERFACE = 315,               /* INTERFACE  */
    IFNAME = 316,                  /* IFNAME  */
    IFTYPE = 317,                  /* IFTYPE  */
    MNIFPREFERENCE = 318,          /* MNIFPREFERENCE  */
    ISTUNNEL = 319,                /* ISTUNNEL  */
    MNUSEALLINTERFACES = 320,      /* MNUSEALLINTERFACES  */
    MNROUTERPROBES = 321,          /* MNROUTERPROBES  */
    MNROUTERPROBETIMEOUT = 322,    /* MNROUTERPROBETIMEOUT  */
    MNDISCARDHAPARAMPROB = 323,    /* MNDISCARDHAPARAMPROB  */
    OPTIMISTICHANDOFF = 324,       /* OPTIMISTICHANDOFF  */
    HOMEPREFIX = 325,              /* HOMEPREFIX  */
    HAACCEPTMOBRTR = 326,          /* HAACCEPTMOBRTR  */
    ISMOBRTR = 327,                /* ISMOBRTR  */
    HASERVEDPREFIX = 328,          /* HASERVEDPREFIX  */
    MOBRTRUSEEXPLICITMODE = 329,   /* MOBRTRUSEEXPLICITMODE  */
    INV_TOKEN = 330                /* INV_TOKEN  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define QSTRING 258
#define ADDR 259
#define BOOL 260
#define NUMBER 261
#define DECIMAL 262
#define NUMPAIR 263
#define MIP6ENTITY 264
#define DEBUGLEVEL 265
#define DEBUGLOGFILE 266
#define DOROUTEOPTIMIZATIONCN 267
#define DOROUTEOPTIMIZATIONMN 268
#define HOMEADDRESS 269
#define HOMEAGENTADDRESS 270
#define INITIALBINDACKTIMEOUTFIRSTREG 271
#define INITIALBINDACKTIMEOUTREREG 272
#define LINKNAME 273
#define HAMAXBINDINGLIFE 274
#define MNMAXHABINDINGLIFE 275
#define MNMAXCNBINDINGLIFE 276
#define MAXMOBPFXADVINTERVAL 277
#define MINMOBPFXADVINTERVAL 278
#define MNHOMELINK 279
#define HAHOMELINK 280
#define NONVOLATILEBINDINGCACHE 281
#define SENDMOBPFXSOLS 282
#define SENDUNSOLMOBPFXADVS 283
#define SENDMOBPFXADVS 284
#define IPSECPOLICYSET 285
#define IPSECPOLICY 286
#define IPSECTYPE 287
#define USEALTCOA 288
#define USEESP 289
#define USEAH 290
#define USEIPCOMP 291
#define BLOCK 292
#define USEMNHAIPSEC 293
#define KEYMNGMOBCAPABILITY 294
#define HOMEREGBINDING 295
#define MH 296
#define MOBPFXDISC 297
#define TUNNELHOMETESTING 298
#define TUNNELMH 299
#define TUNNELPAYLOAD 300
#define USEMOVEMENTMODULE 301
#define USEPOLICYMODULE 302
#define MIP6CN 303
#define MIP6MN 304
#define MIP6HA 305
#define INTERNAL 306
#define MNROPOLICY 307
#define ICMP 308
#define ANY 309
#define DOROUTEOPT 310
#define DEFAULTBINDINGACLPOLICY 311
#define BINDINGACLPOLICY 312
#define MNADDRESS 313
#define USECNBUACK 314
#define INTERFACE 315
#define IFNAME 316
#define IFTYPE 317
#define MNIFPREFERENCE 318
#define ISTUNNEL 319
#define MNUSEALLINTERFACES 320
#define MNROUTERPROBES 321
#define MNROUTERPROBETIMEOUT 322
#define MNDISCARDHAPARAMPROB 323
#define OPTIMISTICHANDOFF 324
#define HOMEPREFIX 325
#define HAACCEPTMOBRTR 326
#define ISMOBRTR 327
#define HASERVEDPREFIX 328
#define MOBRTRUSEEXPLICITMODE 329
#define INV_TOKEN 330

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 112 "gram.y"

	char *string;
	struct in6_addr addr;
	char bool;
	unsigned int num;
	unsigned int numpair[2];
	double dec;

#line 367 "gram.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_GRAM_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_QSTRING = 3,                    /* QSTRING  */
  YYSYMBOL_ADDR = 4,                       /* ADDR  */
  YYSYMBOL_BOOL = 5,                       /* BOOL  */
  YYSYMBOL_NUMBER = 6,                     /* NUMBER  */
  YYSYMBOL_DECIMAL = 7,                    /* DECIMAL  */
  YYSYMBOL_NUMPAIR = 8,                    /* NUMPAIR  */
  YYSYMBOL_MIP6ENTITY = 9,                 /* MIP6ENTITY  */
  YYSYMBOL_DEBUGLEVEL = 10,                /* DEBUGLEVEL  */
  YYSYMBOL_DEBUGLOGFILE = 11,              /* DEBUGLOGFILE  */
  YYSYMBOL_DOROUTEOPTIMIZATIONCN = 12,     /* DOROUTEOPTIMIZATIONCN  */
  YYSYMBOL_DOROUTEOPTIMIZATIONMN = 13,     /* DOROUTEOPTIMIZATIONMN  */
  YYSYMBOL_HOMEADDRESS = 14,               /* HOMEADDRESS  */
  YYSYMBOL_HOMEAGENTADDRESS = 15,          /* HOMEAGENTADDRESS  */
  YYSYMBOL_INITIALBINDACKTIMEOUTFIRSTREG = 16, /* INITIALBINDACKTIMEOUTFIRSTREG  */
  YYSYMBOL_INITIALBINDACKTIMEOUTREREG = 17, /* INITIALBINDACKTIMEOUTREREG  */
  YYSYMBOL_LINKNAME = 18,                  /* LINKNAME  */
  YYSYMBOL_HAMAXBINDINGLIFE = 19,          /* HAMAXBINDINGLIFE  */
  YYSYMBOL_MNMAXHABINDINGLIFE = 20,        /* MNMAXHABINDINGLIFE  */
  YYSYMBOL_MNMAXCNBINDINGLIFE = 21,        /* MNMAXCNBINDINGLIFE  */
  YYSYMBOL_MAXMOBPFXADVINTERVAL = 22,      /* MAXMOBPFXADVINTERVAL  */
  YYSYMBOL_MINMOBPFXADVINTERVAL = 23,      /* MINMOBPFXADVINTERVAL  */
  YYSYMBOL_MNHOMELINK = 24,                /* MNHOMELINK  */
  YYSYMBOL_HAHOMELINK = 25,                /* HAHOMELINK  */
  YYSYMBOL_NONVOLATILEBINDINGCACHE = 26,   /* NONVOLATILEBINDINGCACHE  */
  YYSYMBOL_SENDMOBPFXSOLS = 27,            /* SENDMOBPFXSOLS  */
  YYSYMBOL_SENDUNSOLMOBPFXADVS = 28,       /* SENDUNSOLMOBPFXADVS  */
  YYSYMBOL_SENDMOBPFXADVS = 29,            /* SENDMOBPFXADVS  */
  YYSYMBOL_IPSECPOLICYSET = 30,            /* IPSECPOLICYSET  */
  YYSYMBOL_IPSECPOLICY = 31,               /* IPSECPOLICY  */
  YYSYMBOL_IPSECTYPE = 32,                 /* IPSECTYPE  */
  YYSYMBOL_USEALTCOA = 33,                 /* USEALTCOA  */
  YYSYMBOL_USEESP = 34,                    /* USEESP  */
  YYSYMBOL_USEAH = 35,                     /* USEAH  */
  YYSYMBOL_USEIPCOMP = 36,                 /* USEIPCOMP  */
  YYSYMBOL_BLOCK = 37,                     /* BLOCK  */
  YYSYMBOL_USEMNHAIPSEC = 38,              /* USEMNHAIPSEC  */
  YYSYMBOL_KEYMNGMOBCAPABILITY = 39,       /* KEYMNGMOBCAPABILITY  */
  YYSYMBOL_HOMEREGBINDING = 40,            /* HOMEREGBINDING  */
  YYSYMBOL_MH = 41,                        /* MH  */
  YYSYMBOL_MOBPFXDISC = 42,                /* MOBPFXDISC  */
  YYSYMBOL_TUNNELHOMETESTING = 43,         /* TUNNELHOMETESTING  */
  YYSYMBOL_TUNNELMH = 44,                  /* TUNNELMH  */
  YYSYMBOL_TUNNELPAYLOAD = 45,             /* TUNNELPAYLOAD  */
  YYSYMBOL_USEMOVEMENTMODULE = 46,         /* USEMOVEMENTMODULE  */
  YYSYMBOL_USEPOLICYMODULE = 47,           /* USEPOLICYMODULE  */
  YYSYMBOL_MIP6CN = 48,                    /* MIP6CN  */
  YYSYMBOL_MIP6MN = 49,                    /* MIP6MN  */
  YYSYMBOL_MIP6HA = 50,                    /* MIP6HA  */
  YYSYMBOL_INTERNAL = 51,                  /* INTERNAL  */
  YYSYMBOL_MNROPOLICY = 52,                /* MNROPOLICY  */
  YYSYMBOL_ICMP = 53,                      /* ICMP  */
  YYSYMBOL_ANY = 54,                       /* ANY  */
  YYSYMBOL_DOROUTEOPT = 55,                /* DOROUTEOPT  */
  YYSYMBOL_DEFAULTBINDINGACLPOLICY = 56,   /* DEFAULTBINDINGACLPOLICY  */
  YYSYMBOL_BINDINGACLPOLICY = 57,          /* BINDINGACLPOLICY  */
  YYSYMBOL_MNADDRESS = 58,                 /* MNADDRESS  */
  YYSYMBOL_USECNBUACK = 59,                /* USECNBUACK  */
  YYSYMBOL_INTERFACE = 60,                 /* INTERFACE  */
  YYSYMBOL_IFNAME = 61,                    /* IFNAME  */
  YYSYMBOL_IFTYPE = 62,                    /* IFTYPE  */
  YYSYMBOL_MNIFPREFERENCE = 63,            /* MNIFPREFERENCE  */
  YYSYMBOL_ISTUNNEL = 64,                  /* ISTUNNEL  */
  YYSYMBOL_MNUSEALLINTERFACES = 65,        /* MNUSEALLINTERFACES  */
  YYSYMBOL_MNROUTERPROBES = 66,            /* MNROUTERPROBES  */
  YYSYMBOL_MNROUTERPROBETIMEOUT = 67,      /* MNROUTERPROBETIMEOUT  */
  YYSYMBOL_MNDISCARDHAPARAMPROB = 68,      /* MNDISCARDHAPARAMPROB  */
  YYSYMBOL_OPTIMISTICHANDOFF = 69,         /* OPTIMISTICHANDOFF  */
  YYSYMBOL_HOMEPREFIX = 70,                /* HOMEPREFIX  */
  YYSYMBOL_HAACCEPTMOBRTR = 71,            /* HAACCEPTMOBRTR  */
  YYSYMBOL_ISMOBRTR = 72,                  /* ISMOBRTR  */
  YYSYMBOL_HASERVEDPREFIX = 73,            /* HASERVEDPREFIX  */
  YYSYMBOL_MOBRTRUSEEXPLICITMODE = 74,     /* MOBRTRUSEEXPLICITMODE  */
  YYSYMBOL_INV_TOKEN = 75,                 /* INV_TOKEN  */
  YYSYMBOL_76_ = 76,                       /* ';'  */
  YYSYMBOL_77_ = 77,                       /* '{'  */
  YYSYMBOL_78_ = 78,                       /* '}'  */
  YYSYMBOL_79_ = 79,                       /* '/'  */
  YYSYMBOL_80_ = 80,                       /* '('  */
  YYSYMBOL_81_ = 81,                       /* ')'  */
  YYSYMBOL_82_ = 82,                       /* ','  */
  YYSYMBOL_YYACCEPT = 83,                  /* $accept  */
  YYSYMBOL_grammar = 84,                   /* grammar  */
  YYSYMBOL_topdef = 85,                    /* topdef  */
  YYSYMBOL_mip6entity = 86,                /* mip6entity  */
  YYSYMBOL_ifacedef = 87,                  /* ifacedef  */
  YYSYMBOL_ifacesub = 88,                  /* ifacesub  */
  YYSYMBOL_ifaceopts = 89,                 /* ifaceopts  */
  YYSYMBOL_ifaceopt = 90,                  /* ifaceopt  */
  YYSYMBOL_linksub = 91,                   /* linksub  */
  YYSYMBOL_linkdefs = 92,                  /* linkdefs  */
  YYSYMBOL_linkdef = 93,                   /* linkdef  */
  YYSYMBOL_homeaddress = 94,               /* homeaddress  */
  YYSYMBOL_homeaddrdef = 95,               /* homeaddrdef  */
  YYSYMBOL_ipsecpolicyset = 96,            /* ipsecpolicyset  */
  YYSYMBOL_ipsechaaddrdef = 97,            /* ipsechaaddrdef  */
  YYSYMBOL_ipsecmnaddrdefs = 98,           /* ipsecmnaddrdefs  */
  YYSYMBOL_ipsecmnaddrdef = 99,            /* ipsecmnaddrdef  */
  YYSYMBOL_ipsecmnaddr = 100,              /* ipsecmnaddr  */
  YYSYMBOL_ipsecpolicydefs = 101,          /* ipsecpolicydefs  */
  YYSYMBOL_ipsecpolicydef = 102,           /* ipsecpolicydef  */
  YYSYMBOL_ipsectype = 103,                /* ipsectype  */
  YYSYMBOL_ipsectypeval = 104,             /* ipsectypeval  */
  YYSYMBOL_ipsecprotos = 105,              /* ipsecprotos  */
  YYSYMBOL_ipsecproto = 106,               /* ipsecproto  */
  YYSYMBOL_ipsecreqid = 107,               /* ipsecreqid  */
  YYSYMBOL_xfrmaction = 108,               /* xfrmaction  */
  YYSYMBOL_mnropolicy = 109,               /* mnropolicy  */
  YYSYMBOL_mnropolicyaddr = 110,           /* mnropolicyaddr  */
  YYSYMBOL_dorouteopt = 111,               /* dorouteopt  */
  YYSYMBOL_movemodule = 112,               /* movemodule  */
  YYSYMBOL_policymodule = 113,             /* policymodule  */
  YYSYMBOL_bindaclpolval = 114,            /* bindaclpolval  */
  YYSYMBOL_bindaclpolicy = 115,            /* bindaclpolicy  */
  YYSYMBOL_prefixlen = 116,                /* prefixlen  */
  YYSYMBOL_prefixlistsub = 117,            /* prefixlistsub  */
  YYSYMBOL_prefixlist = 118,               /* prefixlist  */
  YYSYMBOL_prefixlistentry = 119           /* prefixlistentry  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  83
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   259

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  83
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  37
/* YYNRULES -- Number of rules.  */
#define YYNRULES  105
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  219

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   330


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      80,    81,     2,     2,    82,     2,     2,    79,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    76,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    77,     2,    78,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   212,   212,   213,   216,   220,   224,   228,   232,   233,
     237,   241,   245,   249,   253,   257,   261,   270,   279,   288,
     292,   296,   297,   301,   305,   306,   307,   311,   315,   320,
     324,   328,   332,   333,   337,   341,   346,   350,   356,   357,
     358,   361,   404,   405,   408,   409,   412,   416,   427,   433,
     481,   482,   485,   489,   490,   494,   495,   500,   507,   513,
     520,   543,   549,   550,   553,   556,   572,   573,   576,   644,
     647,   648,   649,   650,   651,   652,   653,   654,   658,   662,
     663,   664,   667,   668,   669,   672,   673,   674,   677,   678,
     681,   696,   697,   700,   703,   707,   713,   722,   729,   732,
     749,   759,   760,   763,   764,   767
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "QSTRING", "ADDR",
  "BOOL", "NUMBER", "DECIMAL", "NUMPAIR", "MIP6ENTITY", "DEBUGLEVEL",
  "DEBUGLOGFILE", "DOROUTEOPTIMIZATIONCN", "DOROUTEOPTIMIZATIONMN",
  "HOMEADDRESS", "HOMEAGENTADDRESS", "INITIALBINDACKTIMEOUTFIRSTREG",
  "INITIALBINDACKTIMEOUTREREG", "LINKNAME", "HAMAXBINDINGLIFE",
  "MNMAXHABINDINGLIFE", "MNMAXCNBINDINGLIFE", "MAXMOBPFXADVINTERVAL",
  "MINMOBPFXADVINTERVAL", "MNHOMELINK", "HAHOMELINK",
  "NONVOLATILEBINDINGCACHE", "SENDMOBPFXSOLS", "SENDUNSOLMOBPFXADVS",
  "SENDMOBPFXADVS", "IPSECPOLICYSET", "IPSECPOLICY", "IPSECTYPE",
  "USEALTCOA", "USEESP", "USEAH", "USEIPCOMP", "BLOCK", "USEMNHAIPSEC",
  "KEYMNGMOBCAPABILITY", "HOMEREGBINDING", "MH", "MOBPFXDISC",
  "TUNNELHOMETESTING", "TUNNELMH", "TUNNELPAYLOAD", "USEMOVEMENTMODULE",
  "USEPOLICYMODULE", "MIP6CN", "MIP6MN", "MIP6HA", "INTERNAL",
  "MNROPOLICY", "ICMP", "ANY", "DOROUTEOPT", "DEFAULTBINDINGACLPOLICY",
  "BINDINGACLPOLICY", "MNADDRESS", "USECNBUACK", "INTERFACE", "IFNAME",
  "IFTYPE", "MNIFPREFERENCE", "ISTUNNEL", "MNUSEALLINTERFACES",
  "MNROUTERPROBES", "MNROUTERPROBETIMEOUT", "MNDISCARDHAPARAMPROB",
  "OPTIMISTICHANDOFF", "HOMEPREFIX", "HAACCEPTMOBRTR", "ISMOBRTR",
  "HASERVEDPREFIX", "MOBRTRUSEEXPLICITMODE", "INV_TOKEN", "';'", "'{'",
  "'}'", "'/'", "'('", "')'", "','", "$accept", "grammar", "topdef",
  "mip6entity", "ifacedef", "ifacesub", "ifaceopts", "ifaceopt", "linksub",
  "linkdefs", "linkdef", "homeaddress", "homeaddrdef", "ipsecpolicyset",
  "ipsechaaddrdef", "ipsecmnaddrdefs", "ipsecmnaddrdef", "ipsecmnaddr",
  "ipsecpolicydefs", "ipsecpolicydef", "ipsectype", "ipsectypeval",
  "ipsecprotos", "ipsecproto", "ipsecreqid", "xfrmaction", "mnropolicy",
  "mnropolicyaddr", "dorouteopt", "movemodule", "policymodule",
  "bindaclpolval", "bindaclpolicy", "prefixlen", "prefixlistsub",
  "prefixlist", "prefixlistentry", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    59,   123,   125,    47,
      40,    41,    44
};
#endif

#define YYPACT_NINF (-199)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      66,    -7,    -3,     2,     3,    13,    24,    33,    42,    49,
      52,    57,    75,    77,    40,    79,    92,   102,    43,   105,
     116,    -1,   121,    31,   125,   131,   127,   133,   138,   139,
     140,   142,   143,   145,   146,     0,  -199,  -199,  -199,  -199,
      76,    78,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    73,  -199,    90,    91,    93,    94,   153,    95,
      96,  -199,  -199,    97,  -199,    98,  -199,  -199,    99,   100,
     101,   103,   -25,  -199,   106,   108,   109,   110,   111,   112,
     104,   113,   114,  -199,  -199,  -199,  -199,  -199,  -199,  -199,
    -199,  -199,  -199,  -199,  -199,  -199,  -199,    39,  -199,  -199,
    -199,  -199,   149,   115,   141,  -199,  -199,  -199,  -199,  -199,
     145,    31,  -199,  -199,  -199,    37,  -199,  -199,  -199,  -199,
    -199,  -199,  -199,   170,  -199,  -199,   174,   177,   186,   188,
     190,   191,    -8,  -199,   119,  -199,   193,     1,  -199,    21,
    -199,  -199,    -7,   192,   194,   -29,  -199,  -199,  -199,   122,
     124,   100,   126,   128,  -199,   129,   198,   130,   132,  -199,
    -199,  -199,   134,   135,    74,  -199,   175,  -199,   107,  -199,
     145,   136,   144,   147,  -199,  -199,   170,  -199,  -199,  -199,
    -199,  -199,  -199,  -199,   170,  -199,   170,  -199,  -199,  -199,
    -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,  -199,
    -199,   201,   107,  -199,  -199,  -199,  -199,  -199,   148,  -199,
     204,   209,   107,  -199,  -199,  -199,   150,  -199,  -199
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,     0,     0,     0,     0,     0,     0,
       0,    95,    94,     0,    96,     0,    97,    98,     0,   101,
       0,     0,     0,     8,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     1,     3,     4,     5,     6,    14,    15,
      19,    20,    16,    17,    18,    12,    13,     0,     7,     9,
      10,    11,     0,     0,     0,    22,    23,    24,    25,    26,
       0,     0,    30,    31,    43,     0,    41,    33,    34,    35,
      36,    37,    27,     0,    28,    29,     0,     0,     0,    91,
       0,     0,     0,    50,     0,    32,     0,     0,    62,     0,
     103,    99,     0,     0,     0,     0,    44,   100,   105,     0,
       0,   101,     0,     0,    92,     0,     0,     0,     0,    49,
      51,    61,     0,     0,     0,    63,    60,    66,    78,   102,
       0,     0,     0,     0,    42,    45,     0,    53,    58,    52,
      54,    55,    93,    90,     0,    56,     0,    64,    70,    71,
      72,    73,    74,    75,    76,    77,    69,    67,    82,    83,
      84,    85,    79,   104,    46,    47,    48,    59,     0,    65,
      86,    88,    80,    57,    87,    89,     0,    81,    68
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -199,  -199,   180,   117,  -199,  -199,  -199,    71,  -199,  -199,
     118,  -199,  -199,  -199,  -199,  -199,   120,  -199,  -199,    51,
    -199,  -199,  -199,  -198,  -199,  -199,  -199,  -199,  -199,  -199,
    -199,   123,  -199,   -78,    67,  -199,  -109
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    35,    36,    40,    73,   116,   145,   146,    53,   132,
     133,   150,   151,   103,   104,   137,   138,   163,   166,   167,
     168,   196,   201,   202,   211,   216,   155,   156,   183,    63,
      65,    68,    70,   148,   111,   139,    81
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      83,   140,    61,    41,   212,    42,   126,   127,    43,     1,
       2,     3,     4,     5,   217,   136,     6,     7,    44,     8,
       9,    10,    11,    12,    13,   128,    14,    15,    16,    17,
      18,    45,   164,   142,   143,   144,    66,    67,    19,    20,
      46,    37,    38,    39,   129,    54,    21,    22,    47,   174,
      62,   114,   115,   126,   127,    48,    23,    24,    49,    25,
      26,   203,   130,    50,   131,    27,    28,    29,    30,    31,
     159,    32,   128,    33,    34,     1,     2,     3,     4,     5,
      52,    51,     6,     7,    55,     8,     9,    10,    11,    12,
      13,   129,    14,    15,    16,    17,    18,    56,   207,   142,
     143,   144,   169,   170,    19,    20,   208,    57,   209,   130,
      59,   131,    21,    22,   188,   189,   190,   191,   192,   193,
      58,    60,    23,    24,    64,    25,    26,   194,   195,    69,
      72,    27,    28,    29,    30,    31,    71,    32,    74,    33,
      34,   198,   199,   200,    75,    77,    76,    78,    79,    80,
      97,    82,    85,   134,    86,   136,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    98,    99,   102,   100,
     101,   105,   106,   107,   108,   109,   147,   112,   149,   113,
     110,   152,   117,   123,   118,   119,   120,   121,   122,   124,
     125,   153,   154,   135,   157,   161,   158,   162,   172,   173,
     177,   176,   179,   182,   180,   181,   164,   210,   185,   184,
     214,   187,   204,   186,   215,    84,   175,   197,   178,     0,
     205,     0,     0,   206,   213,     0,   218,     0,     0,     0,
       0,     0,     0,     0,   141,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     160,     0,     0,     0,     0,     0,     0,   165,     0,   171
};

static const yytype_int16 yycheck[] =
{
       0,   110,     3,     6,   202,     3,    14,    15,     5,     9,
      10,    11,    12,    13,   212,    14,    16,    17,     5,    19,
      20,    21,    22,    23,    24,    33,    26,    27,    28,    29,
      30,     7,    31,    62,    63,    64,     5,     6,    38,    39,
       7,    48,    49,    50,    52,     5,    46,    47,     6,    78,
      51,    76,    77,    14,    15,     6,    56,    57,     6,    59,
      60,   170,    70,     6,    72,    65,    66,    67,    68,    69,
      78,    71,    33,    73,    74,     9,    10,    11,    12,    13,
       3,     6,    16,    17,     5,    19,    20,    21,    22,    23,
      24,    52,    26,    27,    28,    29,    30,     5,   176,    62,
      63,    64,    81,    82,    38,    39,   184,     5,   186,    70,
       5,    72,    46,    47,    40,    41,    42,    43,    44,    45,
      77,     5,    56,    57,     3,    59,    60,    53,    54,     4,
       3,    65,    66,    67,    68,    69,     5,    71,     5,    73,
      74,    34,    35,    36,     6,     5,     7,     5,     5,     4,
      77,     5,    76,     4,    76,    14,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    15,    76,
      76,    76,    76,    76,    76,    76,     6,    76,     4,    76,
      80,     4,    76,    79,    76,    76,    76,    76,    76,    76,
      76,     5,     4,    78,     4,    76,     5,     4,     6,     5,
      76,    79,    76,     5,    76,    76,    31,     6,    76,    79,
       6,    76,    76,    79,     5,    35,   145,   166,   151,    -1,
      76,    -1,    -1,    76,    76,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,   142
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     9,    10,    11,    12,    13,    16,    17,    19,    20,
      21,    22,    23,    24,    26,    27,    28,    29,    30,    38,
      39,    46,    47,    56,    57,    59,    60,    65,    66,    67,
      68,    69,    71,    73,    74,    84,    85,    48,    49,    50,
      86,     6,     3,     5,     5,     7,     7,     6,     6,     6,
       6,     6,     3,    91,     5,     5,     5,     5,    77,     5,
       5,     3,    51,   112,     3,   113,     5,     6,   114,     4,
     115,     5,     3,    87,     5,     6,     7,     5,     5,     5,
       4,   119,     5,     0,    85,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    77,    76,    76,
      76,    76,    15,    96,    97,    76,    76,    76,    76,    76,
      80,   117,    76,    76,    76,    77,    88,    76,    76,    76,
      76,    76,    76,    79,    76,    76,    14,    15,    33,    52,
      70,    72,    92,    93,     4,    78,    14,    98,    99,   118,
     119,   114,    62,    63,    64,    89,    90,     6,   116,     4,
      94,    95,     4,     5,     4,   109,   110,     4,     5,    78,
      93,    76,     4,   100,    31,    99,   101,   102,   103,    81,
      82,    86,     6,     5,    78,    90,    79,    76,   117,    76,
      76,    76,     5,   111,    79,    76,    79,    76,    40,    41,
      42,    43,    44,    45,    53,    54,   104,   102,    34,    35,
      36,   105,   106,   119,    76,    76,    76,   116,   116,   116,
       6,   107,   106,    76,     6,     5,   108,   106,    76
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    83,    84,    84,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    86,    86,
      86,    87,    88,    88,    89,    89,    90,    90,    90,    91,
      92,    92,    93,    93,    93,    93,    93,    93,    94,    95,
      96,    97,    98,    98,    99,   100,   101,   101,   102,   103,
     104,   104,   104,   104,   104,   104,   104,   104,   105,   105,
     105,   105,   106,   106,   106,   107,   107,   107,   108,   108,
     109,   110,   110,   111,   112,   112,   113,   114,   114,   115,
     116,   117,   117,   118,   118,   119
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     3,     3,     3,     3,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     3,     3,     3,     3,     3,     1,     1,
       1,     2,     3,     1,     1,     2,     3,     3,     3,     4,
       1,     2,     3,     3,     3,     3,     3,     5,     2,     3,
       3,     3,     1,     2,     3,     3,     1,     2,     5,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       2,     3,     1,     1,     1,     0,     1,     2,     0,     1,
       2,     0,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     0,     3,     1,     3,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* topdef: MIP6ENTITY mip6entity ';'  */
#line 217 "gram.y"
                {
			conf.mip6_entity = (yyvsp[-1].num);
		}
#line 1649 "gram.c"
    break;

  case 5: /* topdef: DEBUGLEVEL NUMBER ';'  */
#line 221 "gram.y"
                {
			conf.debug_level = (yyvsp[-1].num);
		}
#line 1657 "gram.c"
    break;

  case 6: /* topdef: DEBUGLOGFILE QSTRING ';'  */
#line 225 "gram.y"
                {
			conf.debug_log_file = (yyvsp[-1].string);
		}
#line 1665 "gram.c"
    break;

  case 7: /* topdef: NONVOLATILEBINDINGCACHE BOOL ';'  */
#line 229 "gram.y"
                {
			conf.NonVolatileBindingCache = (yyvsp[-1].bool);
		}
#line 1673 "gram.c"
    break;

  case 9: /* topdef: SENDMOBPFXSOLS BOOL ';'  */
#line 234 "gram.y"
                {
			conf.SendMobPfxSols = (yyvsp[-1].bool);
		}
#line 1681 "gram.c"
    break;

  case 10: /* topdef: SENDUNSOLMOBPFXADVS BOOL ';'  */
#line 238 "gram.y"
                {
			conf.SendUnsolMobPfxAdvs = (yyvsp[-1].bool);
		}
#line 1689 "gram.c"
    break;

  case 11: /* topdef: SENDMOBPFXADVS BOOL ';'  */
#line 242 "gram.y"
                {
			conf.SendMobPfxAdvs = (yyvsp[-1].bool);
		}
#line 1697 "gram.c"
    break;

  case 12: /* topdef: MAXMOBPFXADVINTERVAL NUMBER ';'  */
#line 246 "gram.y"
                {
			conf.MaxMobPfxAdvInterval = (yyvsp[-1].num);
		}
#line 1705 "gram.c"
    break;

  case 13: /* topdef: MINMOBPFXADVINTERVAL NUMBER ';'  */
#line 250 "gram.y"
                {
			conf.MinMobPfxAdvInterval = (yyvsp[-1].num);
		}
#line 1713 "gram.c"
    break;

  case 14: /* topdef: DOROUTEOPTIMIZATIONCN BOOL ';'  */
#line 254 "gram.y"
                {
			conf.DoRouteOptimizationCN = (yyvsp[-1].bool);
		}
#line 1721 "gram.c"
    break;

  case 15: /* topdef: DOROUTEOPTIMIZATIONMN BOOL ';'  */
#line 258 "gram.y"
                {
			conf.DoRouteOptimizationMN = (yyvsp[-1].bool);
		}
#line 1729 "gram.c"
    break;

  case 16: /* topdef: HAMAXBINDINGLIFE NUMBER ';'  */
#line 262 "gram.y"
                {
			if ((yyvsp[-1].num) > MAX_BINDING_LIFETIME) {
				uerror("max allowed binding lifetime is %d", 
				       MAX_BINDING_LIFETIME);
				return -1;
			}
			conf.HaMaxBindingLife = (yyvsp[-1].num);
		}
#line 1742 "gram.c"
    break;

  case 17: /* topdef: MNMAXHABINDINGLIFE NUMBER ';'  */
#line 271 "gram.y"
                {
			if ((yyvsp[-1].num) > MAX_BINDING_LIFETIME) {
				uerror("max allowed binding lifetime is %d", 
				       MAX_BINDING_LIFETIME);
				return -1;
			}
			conf.MnMaxHaBindingLife = (yyvsp[-1].num);
		}
#line 1755 "gram.c"
    break;

  case 18: /* topdef: MNMAXCNBINDINGLIFE NUMBER ';'  */
#line 280 "gram.y"
                {
			if ((yyvsp[-1].num) > MAX_RR_BINDING_LIFETIME) {
				uerror("max allowed binding lifetime is %d", 
				       MAX_RR_BINDING_LIFETIME);
				return -1;
			}
			conf.MnMaxCnBindingLife = (yyvsp[-1].num);
		}
#line 1768 "gram.c"
    break;

  case 19: /* topdef: INITIALBINDACKTIMEOUTFIRSTREG DECIMAL ';'  */
#line 289 "gram.y"
                {
			tssetdsec(conf.InitialBindackTimeoutFirstReg_ts, (yyvsp[-1].dec));
		}
#line 1776 "gram.c"
    break;

  case 20: /* topdef: INITIALBINDACKTIMEOUTREREG DECIMAL ';'  */
#line 293 "gram.y"
                {
			tssetdsec(conf.InitialBindackTimeoutReReg_ts, (yyvsp[-1].dec));
		}
#line 1784 "gram.c"
    break;

  case 22: /* topdef: USEMNHAIPSEC BOOL ';'  */
#line 298 "gram.y"
                {
			conf.UseMnHaIPsec = (yyvsp[-1].bool);
		}
#line 1792 "gram.c"
    break;

  case 23: /* topdef: KEYMNGMOBCAPABILITY BOOL ';'  */
#line 302 "gram.y"
                {
			conf.KeyMngMobCapability = (yyvsp[-1].bool);
		}
#line 1800 "gram.c"
    break;

  case 26: /* topdef: DEFAULTBINDINGACLPOLICY bindaclpolval ';'  */
#line 308 "gram.y"
                {
			conf.DefaultBindingAclPolicy = (yyvsp[-1].num);
		}
#line 1808 "gram.c"
    break;

  case 27: /* topdef: HAACCEPTMOBRTR BOOL ';'  */
#line 312 "gram.y"
                {
			conf.HaAcceptMobRtr = (yyvsp[-1].bool);
		}
#line 1816 "gram.c"
    break;

  case 28: /* topdef: HASERVEDPREFIX prefixlistentry ';'  */
#line 316 "gram.y"
                {
			list_splice(&prefixes,
				    conf.nemo_ha_served_prefixes.prev);
		}
#line 1825 "gram.c"
    break;

  case 29: /* topdef: MOBRTRUSEEXPLICITMODE BOOL ';'  */
#line 321 "gram.y"
                {
			conf.MobRtrUseExplicitMode = (yyvsp[-1].bool);
		}
#line 1833 "gram.c"
    break;

  case 30: /* topdef: BINDINGACLPOLICY bindaclpolicy ';'  */
#line 325 "gram.y"
                {
			bae = NULL;
		}
#line 1841 "gram.c"
    break;

  case 31: /* topdef: USECNBUACK BOOL ';'  */
#line 329 "gram.y"
                {
			conf.CnBuAck = (yyvsp[-1].bool) ? IP6_MH_BU_ACK : 0;
		}
#line 1849 "gram.c"
    break;

  case 33: /* topdef: MNUSEALLINTERFACES BOOL ';'  */
#line 334 "gram.y"
                {
			conf.MnUseAllInterfaces = (yyvsp[-1].bool) ? POL_MN_IF_DEF_PREFERENCE : 0;
		}
#line 1857 "gram.c"
    break;

  case 34: /* topdef: MNROUTERPROBES NUMBER ';'  */
#line 338 "gram.y"
                {
			conf.MnRouterProbes = (yyvsp[-1].num);
		}
#line 1865 "gram.c"
    break;

  case 35: /* topdef: MNROUTERPROBETIMEOUT DECIMAL ';'  */
#line 342 "gram.y"
                {
			if ((yyvsp[-1].dec) > 0)
				tssetdsec(conf.MnRouterProbeTimeout_ts, (yyvsp[-1].dec));
		}
#line 1874 "gram.c"
    break;

  case 36: /* topdef: MNDISCARDHAPARAMPROB BOOL ';'  */
#line 347 "gram.y"
                {
			conf.MnDiscardHaParamProb = (yyvsp[-1].bool);
		}
#line 1882 "gram.c"
    break;

  case 37: /* topdef: OPTIMISTICHANDOFF BOOL ';'  */
#line 351 "gram.y"
                {
			conf.OptimisticHandoff = (yyvsp[-1].bool);
		}
#line 1890 "gram.c"
    break;

  case 38: /* mip6entity: MIP6CN  */
#line 356 "gram.y"
                         { (yyval.num) = MIP6_ENTITY_CN;	}
#line 1896 "gram.c"
    break;

  case 39: /* mip6entity: MIP6MN  */
#line 357 "gram.y"
                         { (yyval.num) = MIP6_ENTITY_MN; }
#line 1902 "gram.c"
    break;

  case 40: /* mip6entity: MIP6HA  */
#line 358 "gram.y"
                         { (yyval.num) = MIP6_ENTITY_HA; }
#line 1908 "gram.c"
    break;

  case 41: /* ifacedef: QSTRING ifacesub  */
#line 362 "gram.y"
                {
			struct net_iface *nni;
			strncpy(ni.name, (yyvsp[-1].string), IF_NAMESIZE - 1);
			ni.ifindex = if_nametoindex((yyvsp[-1].string));

			if (is_if_ha(&ni) && ni.is_tunnel) {
				/* We do not allow tunnel interfaces
				   for HA, only for MN and CN */
				uerror("Use of tunnel interface is not"
				       " possible for HA yet");
				free((yyvsp[-1].string));
				return -1;
			}
			if (ni.ifindex <= 0) {
				if (is_if_ha(&ni)) {
					/* We do not allow unavailable
					   ifaces for HA ... */
					uerror("HA interface %s "
					       "unavailable", (yyvsp[-1].string));
					free((yyvsp[-1].string));
					return -1;
				}
				/* ... but allow them for CN and MN */
			}
			free((yyvsp[-1].string));

			nni = malloc(sizeof(struct net_iface));
			if (nni == NULL) {
				uerror("out of memory");
				return -1;
			}
			memcpy(nni, &ni, sizeof(struct net_iface));
			list_add_tail(&nni->list, &conf.net_ifaces);
			if (is_if_ha(nni))
				homeagent_if_init(nni->ifindex);

			memset(&ni, 0, sizeof(struct net_iface));
			ni.mip6_if_entity = MIP6_ENTITY_NO;
			ni.mn_if_preference = POL_MN_IF_DEF_PREFERENCE;
		}
#line 1953 "gram.c"
    break;

  case 46: /* ifaceopt: IFTYPE mip6entity ';'  */
#line 413 "gram.y"
                {
			ni.mip6_if_entity = (yyvsp[-1].num);
		}
#line 1961 "gram.c"
    break;

  case 47: /* ifaceopt: MNIFPREFERENCE NUMBER ';'  */
#line 417 "gram.y"
                {
			int pref = (yyvsp[-1].num);
			if ((pref > POL_MN_IF_MIN_PREFERENCE) || (pref < 0)) {
				uerror("Found bad interface preference value "
				       "(%d). Valid range is [0,%d].\n", pref,
				       POL_MN_IF_MIN_PREFERENCE);
				return -1;
			}
 			ni.mn_if_preference = pref;
		}
#line 1976 "gram.c"
    break;

  case 48: /* ifaceopt: ISTUNNEL BOOL ';'  */
#line 428 "gram.y"
                {
			ni.is_tunnel = (yyvsp[-1].bool);
		}
#line 1984 "gram.c"
    break;

  case 49: /* linksub: QSTRING '{' linkdefs '}'  */
#line 434 "gram.y"
                {
			struct home_addr_info *nhai;
			if (IN6_IS_ADDR_UNSPECIFIED(&hai.hoa.addr)) {
				uerror("No home addresses defined"
					"for homelink %d", hai.if_home);
				return -1;
			}
			strncpy(hai.name, (yyvsp[-3].string), IF_NAMESIZE - 1);
			hai.if_home = if_nametoindex((yyvsp[-3].string));
			free((yyvsp[-3].string));
			if (hai.if_home <= 0) {
				uerror("invalid interface");
				return -1;
			}
			nhai = malloc(sizeof(struct home_addr_info));
			if (nhai == NULL) {
				uerror("out of memory");
				return -1;
			}
			if (hai.plen == 64) {
				struct in6_addr lladdr;
				ipv6_addr_llocal(&hai.hoa.addr, &lladdr);
				if (!addr_do(&lladdr, 64, 
					     hai.if_home, NULL, NULL))
					hai.lladdr_comp = IP6_MH_BU_LLOCAL;
			}
			if (IN6_IS_ADDR_UNSPECIFIED(&hai.home_prefix)) {
				ipv6_addr_prefix(&hai.home_prefix, 
						 &hai.hoa.addr, hai.plen);
				hai.home_plen = hai.plen;
			}
			memcpy(nhai, &hai, sizeof(struct home_addr_info));
			INIT_LIST_HEAD(&nhai->ro_policies);
			INIT_LIST_HEAD(&nhai->ha_list.home_agents);
			INIT_LIST_HEAD(&nhai->mob_net_prefixes);
			nhai->ha_list.dhaad_id = -1;
			list_splice(&hai.ro_policies, &nhai->ro_policies);
			list_splice(&hai.mob_net_prefixes,
				    &nhai->mob_net_prefixes);
			list_add_tail(&nhai->list, &conf.home_addrs);

			memset(&hai, 0, sizeof(struct home_addr_info));
			INIT_LIST_HEAD(&hai.ro_policies);
			INIT_LIST_HEAD(&hai.mob_net_prefixes);
		}
#line 2034 "gram.c"
    break;

  case 52: /* linkdef: HOMEAGENTADDRESS ADDR ';'  */
#line 486 "gram.y"
                {
			memcpy(&hai.ha_addr, &(yyvsp[-1].addr), sizeof(struct in6_addr));
		}
#line 2042 "gram.c"
    break;

  case 54: /* linkdef: USEALTCOA BOOL ';'  */
#line 491 "gram.y"
                {
		        hai.altcoa = (yyvsp[-1].bool);
		}
#line 2050 "gram.c"
    break;

  case 56: /* linkdef: ISMOBRTR BOOL ';'  */
#line 496 "gram.y"
                {
			if ((yyvsp[-1].bool))
				hai.mob_rtr = IP6_MH_BU_MR;
		}
#line 2059 "gram.c"
    break;

  case 57: /* linkdef: HOMEPREFIX ADDR '/' prefixlen ';'  */
#line 501 "gram.y"
                {
			ipv6_addr_prefix(&hai.home_prefix, &(yyvsp[-3].addr), (yyvsp[-1].num));
			hai.home_plen = (yyvsp[-1].num);
		}
#line 2068 "gram.c"
    break;

  case 58: /* homeaddress: homeaddrdef prefixlistsub  */
#line 508 "gram.y"
                {
			hai.mnp_count = mv_prefixes(&hai.mob_net_prefixes);
		}
#line 2076 "gram.c"
    break;

  case 59: /* homeaddrdef: ADDR '/' prefixlen  */
#line 514 "gram.y"
                {
			hai.hoa.addr = (yyvsp[-2].addr);
			hai.plen = (yyvsp[0].num);
		}
#line 2085 "gram.c"
    break;

  case 60: /* ipsecpolicyset: ipsechaaddrdef ipsecmnaddrdefs ipsecpolicydefs  */
#line 521 "gram.y"
                {
			if (!list_empty(&ipsec_ps.hoa_list)) {
				struct list_head *lp, *tmp;

				/* free each hoa entry */
				list_for_each_safe(lp, tmp,
						   &ipsec_ps.hoa_list) {
					struct home_addr_info *hoa;

					list_del(lp);
					hoa = list_entry(lp,
							 struct home_addr_info,
							 list);

					free(hoa);
				}
			}
			memset(&ipsec_ps, 0, sizeof(ipsec_ps));
			INIT_LIST_HEAD(&ipsec_ps.hoa_list);
		}
#line 2110 "gram.c"
    break;

  case 61: /* ipsechaaddrdef: HOMEAGENTADDRESS ADDR ';'  */
#line 544 "gram.y"
                {
			ipsec_ps.ha = (yyvsp[-1].addr);
		}
#line 2118 "gram.c"
    break;

  case 65: /* ipsecmnaddr: ADDR '/' prefixlen  */
#line 557 "gram.y"
                {
			struct home_addr_info *hai;

			hai = malloc(sizeof(struct home_addr_info));
			if (hai == NULL) {
				uerror("out of memory");
				return -1;
			}
			memset(hai, 0, sizeof(struct home_addr_info)); 
			hai->hoa.addr = (yyvsp[-2].addr);
			hai->plen = (yyvsp[0].num);
			list_add_tail(&hai->list, &ipsec_ps.hoa_list);
		}
#line 2136 "gram.c"
    break;

  case 68: /* ipsecpolicydef: ipsectype ipsecprotos ipsecreqid xfrmaction ';'  */
#line 577 "gram.y"
                {
			struct list_head *lp;

			if (IN6_IS_ADDR_UNSPECIFIED(&ipsec_ps.ha)) {
				uerror("HomeAgentAddress missing for IPsecPolicy");
				return -1;
			}
			if (list_empty(&ipsec_ps.hoa_list)) {
				uerror("HomeAddress missing for IPsecPolicy");
				return -1;
			}

			list_for_each(lp, &ipsec_ps.hoa_list) {
				struct home_addr_info *hai;
				struct ipsec_policy_entry *e;

				hai = list_entry(lp, struct home_addr_info,
						 list);

				e = malloc(sizeof(*e));
				if (e == NULL) {
					uerror("out of memory");
					return -1;
				}
				memset(e, 0, sizeof(*e));
				e->ha_addr = ipsec_ps.ha;
				e->mn_addr = hai->hoa.addr;
				e->type = (yyvsp[-4].num);
#ifndef XFRM_MSG_MIGRATE
				switch (e->type) {
				case IPSEC_POLICY_TYPE_TUNNELHOMETESTING:
				case IPSEC_POLICY_TYPE_TUNNELMH:
				case IPSEC_POLICY_TYPE_TUNNELPAYLOAD:
					uerror("cannot use IPsec tunnel because it is not built with MIGRATE");
					return -1;
				default:
					break;
				}
#endif
#ifndef MULTIPROTO_MIGRATE
				if ((yyvsp[-3].num) != IPSEC_PROTO_ESP) {
					uerror("only UseESP is allowed");
					return -1;
				}
#endif
				e->ipsec_protos = (yyvsp[-3].num);
				e->reqid_toha = (yyvsp[-2].numpair)[0];
				e->reqid_tomn = (yyvsp[-2].numpair)[1];
				e->action = (yyvsp[-1].bool);

				if (ipsec_policy_entry_check(&e->ha_addr,
							     &e->mn_addr,
							     e->type)) {
					uerror("overlapping IPsec policies "
					       "found for "
					       "HA %x:%x:%x:%x:%x:%x:%x:%x "
					       "MN %x:%x:%x:%x:%x:%x:%x:%x "
					       "pair\n",
					       NIP6ADDR(&e->ha_addr),
					       NIP6ADDR(&e->mn_addr));
					return -1;
				}
				list_add_tail(&e->list, &conf.ipsec_policies);
			}
		}
#line 2206 "gram.c"
    break;

  case 69: /* ipsectype: IPSECPOLICY ipsectypeval  */
#line 644 "gram.y"
                                           { (yyval.num) = (yyvsp[0].num); }
#line 2212 "gram.c"
    break;

  case 70: /* ipsectypeval: HOMEREGBINDING  */
#line 647 "gram.y"
                                 { (yyval.num) = IPSEC_POLICY_TYPE_HOMEREGBINDING; }
#line 2218 "gram.c"
    break;

  case 71: /* ipsectypeval: MH  */
#line 648 "gram.y"
                     { (yyval.num) = IPSEC_POLICY_TYPE_MH; }
#line 2224 "gram.c"
    break;

  case 72: /* ipsectypeval: MOBPFXDISC  */
#line 649 "gram.y"
                             { (yyval.num) = IPSEC_POLICY_TYPE_MOBPFXDISC; }
#line 2230 "gram.c"
    break;

  case 73: /* ipsectypeval: TUNNELHOMETESTING  */
#line 650 "gram.y"
                                    { (yyval.num) = IPSEC_POLICY_TYPE_TUNNELHOMETESTING; }
#line 2236 "gram.c"
    break;

  case 74: /* ipsectypeval: TUNNELMH  */
#line 651 "gram.y"
                           { (yyval.num) = IPSEC_POLICY_TYPE_TUNNELMH; }
#line 2242 "gram.c"
    break;

  case 75: /* ipsectypeval: TUNNELPAYLOAD  */
#line 652 "gram.y"
                                { (yyval.num) = IPSEC_POLICY_TYPE_TUNNELPAYLOAD; }
#line 2248 "gram.c"
    break;

  case 76: /* ipsectypeval: ICMP  */
#line 653 "gram.y"
                       { (yyval.num) = IPSEC_POLICY_TYPE_ICMP; }
#line 2254 "gram.c"
    break;

  case 77: /* ipsectypeval: ANY  */
#line 654 "gram.y"
                      { (yyval.num) = IPSEC_POLICY_TYPE_ANY; }
#line 2260 "gram.c"
    break;

  case 78: /* ipsecprotos: %empty  */
#line 658 "gram.y"
                {
			uerror("IPsecPolicy must set at least one protocol");
			return -1;
		}
#line 2269 "gram.c"
    break;

  case 79: /* ipsecprotos: ipsecproto  */
#line 662 "gram.y"
                             { (yyval.num) = (yyvsp[0].num); }
#line 2275 "gram.c"
    break;

  case 80: /* ipsecprotos: ipsecproto ipsecproto  */
#line 663 "gram.y"
                                        { (yyval.num) = (yyvsp[-1].num) | (yyvsp[0].num); }
#line 2281 "gram.c"
    break;

  case 81: /* ipsecprotos: ipsecproto ipsecproto ipsecproto  */
#line 664 "gram.y"
                                                   { (yyval.num) = (yyvsp[-2].num) | (yyvsp[-1].num) | (yyvsp[0].num); }
#line 2287 "gram.c"
    break;

  case 82: /* ipsecproto: USEESP  */
#line 667 "gram.y"
                         { (yyval.num) = IPSEC_PROTO_ESP; }
#line 2293 "gram.c"
    break;

  case 83: /* ipsecproto: USEAH  */
#line 668 "gram.y"
                        { (yyval.num) = IPSEC_PROTO_AH; }
#line 2299 "gram.c"
    break;

  case 84: /* ipsecproto: USEIPCOMP  */
#line 669 "gram.y"
                            { (yyval.num) = IPSEC_PROTO_IPCOMP; }
#line 2305 "gram.c"
    break;

  case 85: /* ipsecreqid: %empty  */
#line 672 "gram.y"
                  { (yyval.numpair)[0] = (yyval.numpair)[1] = 0; }
#line 2311 "gram.c"
    break;

  case 86: /* ipsecreqid: NUMBER  */
#line 673 "gram.y"
                         { (yyval.numpair)[0] = (yyval.numpair)[1] = (yyvsp[0].num); }
#line 2317 "gram.c"
    break;

  case 87: /* ipsecreqid: NUMBER NUMBER  */
#line 674 "gram.y"
                                { (yyval.numpair)[0] = (yyvsp[-1].num); (yyval.numpair)[1] = (yyvsp[0].num); }
#line 2323 "gram.c"
    break;

  case 88: /* xfrmaction: %empty  */
#line 677 "gram.y"
                  { (yyval.bool) = XFRM_POLICY_ALLOW; }
#line 2329 "gram.c"
    break;

  case 89: /* xfrmaction: BOOL  */
#line 678 "gram.y"
                       { (yyval.bool) = (yyvsp[0].bool) ? XFRM_POLICY_ALLOW : XFRM_POLICY_BLOCK; }
#line 2335 "gram.c"
    break;

  case 90: /* mnropolicy: mnropolicyaddr dorouteopt  */
#line 682 "gram.y"
                { 
			struct xfrm_ro_pol *rp;
			rp = malloc(sizeof(struct xfrm_ro_pol));
			if (rp == NULL) {
				uerror("out of memory");
				return -1;
			}
			memset(rp, 0, sizeof(struct xfrm_ro_pol)); 
			rp->cn_addr = (yyvsp[-1].addr);
			rp->do_ro = (yyvsp[0].bool);
			list_add_tail(&rp->list, &hai.ro_policies);
		}
#line 2352 "gram.c"
    break;

  case 91: /* mnropolicyaddr: %empty  */
#line 696 "gram.y"
                  { (yyval.addr) = in6addr_any; }
#line 2358 "gram.c"
    break;

  case 92: /* mnropolicyaddr: ADDR  */
#line 697 "gram.y"
                       { (yyval.addr) = (yyvsp[0].addr); }
#line 2364 "gram.c"
    break;

  case 93: /* dorouteopt: BOOL  */
#line 700 "gram.y"
                       { (yyval.bool) = (yyvsp[0].bool); }
#line 2370 "gram.c"
    break;

  case 94: /* movemodule: INTERNAL  */
#line 704 "gram.y"
                {
			conf.MoveModulePath = NULL;
		}
#line 2378 "gram.c"
    break;

  case 95: /* movemodule: QSTRING  */
#line 708 "gram.y"
                {
			conf.MoveModulePath = NULL;
		}
#line 2386 "gram.c"
    break;

  case 96: /* policymodule: QSTRING  */
#line 714 "gram.y"
                {
			if (pmgr_init((yyvsp[0].string), &conf.pmgr) < 0) {
				uerror("error loading shared object %s", (yyvsp[0].string));
				return -1;
			}
		}
#line 2397 "gram.c"
    break;

  case 97: /* bindaclpolval: BOOL  */
#line 723 "gram.y"
                { 
			if ((yyvsp[0].bool))
				(yyval.num) = IP6_MH_BAS_ACCEPTED;
			else
				(yyval.num) = IP6_MH_BAS_PROHIBIT;
		}
#line 2408 "gram.c"
    break;

  case 98: /* bindaclpolval: NUMBER  */
#line 729 "gram.y"
                         { (yyval.num) = (yyvsp[0].num); }
#line 2414 "gram.c"
    break;

  case 99: /* bindaclpolicy: ADDR prefixlistsub bindaclpolval  */
#line 733 "gram.y"
                {
			bae = malloc(sizeof(struct policy_bind_acl_entry));
			if (bae == NULL) {
				uerror("out of memory");
				return -1;
			}
			memset(bae, 0, sizeof(struct policy_bind_acl_entry)); 
			bae->hoa = (yyvsp[-2].addr);
			bae->plen = 128;
			INIT_LIST_HEAD(&bae->mob_net_prefixes);
			bae->mnp_count = mv_prefixes(&bae->mob_net_prefixes);
			bae->bind_policy = (yyvsp[0].num);
			list_add_tail(&bae->list, &conf.bind_acl);
		}
#line 2433 "gram.c"
    break;

  case 100: /* prefixlen: NUMBER  */
#line 750 "gram.y"
                {
			if ((yyvsp[0].num) > 128) {
				uerror("invalid prefix length %d", (yyvsp[0].num));
				return -1;
			}
			(yyval.num) = (yyvsp[0].num);
		}
#line 2445 "gram.c"
    break;

  case 105: /* prefixlistentry: ADDR '/' prefixlen  */
#line 768 "gram.y"
                {
			struct prefix_list_entry *p;
			p = malloc(sizeof(struct prefix_list_entry));
			if (p == NULL) {
				fprintf(stderr,
					"%s: out of memory\n", __FUNCTION__);
				return -1;
			}
			memset(p, 0, sizeof(struct prefix_list_entry));
			p->ple_prefix = (yyvsp[-2].addr);
			p->ple_plen = (yyvsp[0].num);
			list_add_tail(&p->list, &prefixes);
		}
#line 2463 "gram.c"
    break;


#line 2467 "gram.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 782 "gram.y"

